{
  Autor       : Michel Springwald

  Erstellt am : Samstag den 28.April.2007
  Upgedatet   : Donnerstag den 03.Mai.2007
  Histroy     :
}

unit u7Zip;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ComCtrls, ExtCtrls, StdCtrls, Buttons,LCLType,LCLIntf,types,Spin,
  Unit2,
  Tools_File,Tools,uThread,u7zipExtra;
type
  TOnSetStop = procedure(const Value:Boolean) of Object;
  TOnSetEnabled = procedure(const Typ:Integer; const Value:Boolean) of Object;


  { T7Zip }

  T7Zip = class
  private
    Thread:TOpenArchiv;
    fOnStopValue:TOnSetStop;
    fOnSetEnabled:TOnSetEnabled;
  public
    ListViewA,ListViewB:TListView;
    comboBoxA,ComboBoxB:TComboBox;
    status:String;
    procedure StopThread;
    procedure SynEvt;
    procedure run7Za(const Para:String;const lw:TListView);
    procedure Load7za(const ListView:TListView;const str:String);
    procedure ChangeDir(const ListView:TListView; const comboBox:TComboBox);
    procedure SetFileName(const pFileName:String);
    procedure CreateListe(const ListView:TListView;const ComboBox:TComboBox;pFileName:String;const del:Boolean = false;l:Boolean = False);
    procedure NewArchiv;
    procedure DeleteItems;
    procedure AddItems(isAdd:Boolean = False);
    procedure ExtractArchiv;
  published
    property onStop:TOnSetStop read fOnStopValue write fOnStopValue;
    property onEnabled:TOnSetEnabled read fOnSetEnabled write fOnSetEnabled;

  end;


implementation

uses Unit1;

procedure T7Zip.NewArchiv;
var
  str:String;
  index,i:Integer;
begin
  if ListViewA.SelCount > 0 then begin
    if Form2.ShowModal = mrOK then begin
      if Form2.RadioGroup1.ItemIndex > -1 then
        str:='a -t' + Form2.RadioGroup1.Items[Form2.RadioGroup1.ItemIndex] + ' ';

      if Form2.FileNameEdit1.Text = '' then begin
        ShowMessage('Bitte Dateinamen angeben !');
        Form2.FileNameEdit1.SetFocus;
        exit;
      end;

      FileName:=Form2.FileNameEdit1.FileName;
      if Pos('"',FileName) = 0 then
        FileName:='"'+FileName+'"';

      // für die Packerate wird der Level ausgerchnet
      index:=Form2.ComboBox1.ItemIndex;
      case index of 0:index:=1;1:index:=3;2:index:=5;3:index:=7;4:index:=9;end;

      if Form2.Notebook1.PageIndex = 1 then begin
        // Die Methode wird hinzufügt
        if (Form2.RadioGroup1.itemIndex = 0) and (Form2.RadioGroup2.itemIndex > -1) then
          str:=str + '-m' +Form2.RadioGroup2.items[Form2.RadioGroup2.itemIndex];

        if Form2.CheckListBox1.Checked[0] = False then str:=str+' -s=off ';
        if Form2.CheckListBox1.Checked[1] = False then str:=str+' -f=off ';
        if Form2.CheckListBox1.Checked[2] = False then str:=str+' -hc=off ';
        if Form2.CheckListBox1.Checked[3] = False then str:=str+' -hcf=off ';
        if Form2.CheckListBox1.Checked[4] = True then str:=str+' -he=on ';
        if Form2.CheckListBox1.Checked[5] = False then str:=str+' -mt=off ';
      end;
      // Datei Liste erstellen
      CreateListe(ListViewA,ComboBoxA,TempDir + '/NeueList.lst');
      str:=str + ' -mx'+intTostr(index) + ' "'+FileName+'"'+ ' @NeueList.lst -w'+ExtractFilePath(FileName);
      // Fügt die Einträge zur ListViewB hinzu
      ComboBoxB.Text:=''; dirLevel:=1; ListViewB.Clear;

      run7Za(str,ListViewB);
      writeln('FileName: ', FileName);
      NewDir:='New';
      
      //CopySelItems(ListViewA, ListViewB,false,true);


      for i:=0 to ListViewA.Items.count-1 do
       ListViewA.Items[i].Selected:=False;
    end
    else
      writeln('Abbruch vom erstellen');
  end
  else begin
    ShowmEssage('Es sind keine Daten Markiert'); ListViewA.SetFocus;
  end;
end;

procedure T7Zip.DeleteItems;
var
  Para:String;
begin
  Writeln('T7Zip.DeleteItems.Begin');
  // erstellt die AddListe und speichert sie im TempDir ab
  // setzt das Aktuelel Verzeichnis auf TempDir.

  Writeln('T7Zip.DeleteItems.TempDir: ',TempDir + 'dellist.lst');
  CreateListe(ListViewB,ComboboxB,TempDir + 'dellist.lst',True);

  Para:='d ' + FileName + ' @dellist.lst -r -w'+ExtractFilePath(Filename)+'"';
  writeln('DeleteItems.GetCurrentDir: ', GetCurrentDir);
  writeln('DeleteItems.Parameter: ',Para);

  // den Eigentlichen lösch vorgang starten,
  // von einer Dateiliste dellist
  run7Za(para,ListViewB);
  Writeln('T7Zip.DeleteItems.End');
end;

procedure T7Zip.AddItems(isAdd:Boolean = False);
var
  para,s:String;
begin
  Writeln('T7Zip.AddItems.Begin');
  if ListViewA.SelCount > 0 then begin
    // Nur machen, wenn ein Archiv bereits geöffnet ist
    if FileName <> '' then begin
      // Nur machen wenn es ein Root Verzeichnis ist
      s:=comboBoxB.Text;
      if s[1] = '/' then s:='';
      if s = '' then begin
        // erstellt die AddListe und speichert sie im TempDir ab
        // setzt das Aktuelel Verzeichnis auf TempDir.
        Writeln('T7Zip.AddItems.TempDir: ',TempDir + 'dellist.lst');
        CreateListe(ListViewA,ComboboxA,TempDir+'addlist.list');
        Para:='a '+ FileName + ' @addlist.list ' + '-w'+GetToken(ExtractFilePath(FileName),'"',2);

        writeln('T7Zip.AddItems.GetCurrentDir: ', GetCurrentDir);
        writeln('T7Zip.AddItems.Parameter: ',para);
        // start das Hinzufügen von der console
        run7Za(para,ListViewB);
        // Setzt das Archiv auf Root Verzeichnis
        comboBoxB.Text:=''; dirLevel:=1;
        // Kopiert die Markirten Einträge von ListView1 nach ListView2
        CopySelItems(ListViewA,ListViewB);
      end
      else begin
        writeln('AddItems:Im Moment werden Unterverzeichniss noch nicht unterstützt');
        ShowMessage('Im Moment werden Unterverzeichniss noch nicht unterstützt');
      end
    end // if FileName <> ''
    else // Wenn keins geöffnet ist, ein neues Erstellen.
      NewArchiv;
  end
  else begin
    writeln('AddItems:Es sind keine Einträge markiert !');
    ShowMessage('Es sind keine Einträge markiert !');
  end;
  
  Writeln('T7Zip.AddItems.End');
end;

procedure T7Zip.StopThread;
begin
  Thread.Cancel:=True;
  onStop(False);
  onEnabled(1,False);
end;

procedure T7Zip.SynEvt;
begin
  case Thread.fSynModus of
    SPEnabledTrue: begin
      aDirCount:=0; aFileCount:=0; aTotalSize:=0; aCompressSize:=0;
      onStop(True);
      onEnabled(1,True);
    end;
    
    SPEnabledFalse: begin
      if NewDir = 'New' then begin
        Load7za(ListViewB,FileName);
        NewDir:='';
      end;

      onStop(False);
      onEnabled(1,False);
      if Assigned(onArchivInfo) then onArchivInfo(aDirCount,aFileCount,aTotalSize,aCompressSize);

    end;

    LWAddItems: AddLV(Thread.lw,Thread.items,dirLevel);
    lwpunkt: AddLV(Thread.lw,nil,dirLevel);
    prosessbar:begin
      Thread.Suspended:=True;
      status:=Thread.status;
      onEnabled(2,False);
      Thread.Resume;
    end;
    
     DirLoadNew: LoadDir(comboBoxA.Text,ListViewA);
  end;
end;

procedure T7Zip.CreateListe(const ListView:TListView;const ComboBox:TComboBox;pFileName:String;const del:Boolean = false;l:Boolean = False);
var
  i:Integer;
  s,str:String;
begin
  for i:=ListView.items.count-1 downto 0 do begin
    if ListView.Items[i].Selected = True then begin
      if ListView.Items[i].Caption[1] <> '[' then begin
        str:=ComboBox.Text;
        // Damit 7z kein fehler von sich gibt
        // muss das / an erste stelle gelöscht werden, fals vorhanden
        if l = True then begin
          if (str <> '') and (str[1] = '/') then
            str:=copy(str,2,Length(str));
         end;
        // verzeichnis wird gebildet aus ComboBoxB und den Caption
        s:=str + ListView.Items[i].Caption
      end
      else begin
        str:=copy(ListView.Items[i].Caption,2,Length(ListView.Items[i].Caption)-2);
        s:=comboBox.text +str;
      end;
      if s <> '' then begin
        if del = False then
          Files.Add('"'+s+'"')
        else
          Files.Add(s);
      end;
      
      if del = True then
        ListView.Items[i].Delete;
    end;
  end;
  SaveFileList(pFileName);
end;


procedure T7Zip.SetFileName(const pFileName:String);
begin
  FileName:='"'+pFileName+'"';
  Files.Clear;
  onEnabled(0,Filename <> '');
end;

procedure T7Zip.run7Za(const Para:String;const lw:TListView);
begin
  Thread:=TOpenArchiv.Create(True);
  Thread.dirlevel:=dirLevel;
  Thread.OnSyncEvent:=@SynEvt;
  Thread.lw:=lw;
  Thread.Para:=Para;
  Thread.Resume;
end;

procedure T7Zip.Load7za(const ListView:TListView;const str:String);
begin
  ListView.Clear; run7Za('l ' + str + ' -slt',ListView);
end;

procedure T7Zip.ChangeDir(const ListView:TListView; const comboBox:TComboBox);
var
  str,d:String;
begin
  if (ListView.Selected <> NIl) and (listview.Selected.Data <> NIL) then begin
    str:=TDir(listview.items[listview.Selected.Index].Data).dir;
    if ExtractFileName(str) <> '' then d:=TempDir + ExtractFileName(str) + '/';
    // Wenn es schon ein Verzeichnis mit dem Namen gibt
    // verwende es.
    if DirectoryExists(d) = True then TDir(listview.Selected.Data).TempName:=d;
    // Wenn im Dateinamen .. vorkommt ein Verzeichnisebe Tifer gehen
    if pos('..',str) > 0 then begin
      comboBox.Text:=GetPrvDir1(comboBox.text);
      // Neues Verzeichnis Auslesen und in die angeben ListView laden
      LoadDir(ComboBox.Text,ListView);
    end
    else begin
      // Wenn es kein Verzeichnis ist:
      if listview.Selected.caption[1] <> '[' then begin
        dirlevel:=1;
//        writeln(TDir(listview.items[listview.Selected.Index].Data).TempName);
        if (TDir(listview.items[listview.Selected.Index].Data).TempName ='') and (ListViewB.Tag <> -2) then begin
          SetFileName(str);  //Writeln('R:',Random(200) );
          Load7za(ListViewB,FileName + ' ');
          listviewA.Tag:=-1; ListViewB.Tag:=0;
        end
        else begin
          // nur laden wenn es kein Datei ist
          ListViewB.Tag:=-2;
          ComboBoxB.text:=TDir(listview.items[listview.Selected.Index].Data).TempName;
          LoadDir(ComboBoxB.text,ListViewB)
        end;
      end
      else begin
        // Wenn es ein verzeichnis ist, dann wechsel ist
        comboBox.Text:=str;LoadDir(ComboBox.Text,ListView);
      end;
    end
  end; // if Data <> NIL and Sele <> NIL then
end;

procedure T7Zip.ExtractArchiv;
var
  str,p:String;
begin
  // Einträge werden nach ListView1 Kopiert
 // CopySelItems(ListViewB,ListViewA,False);
  
  // Datei Liste wird erstellt
  CreateListe(ListViewB,comboBoxB,TempDir+'extract.list',false);

  str:=comboBoxA.text;
  p:='x ' + FileName + ' -o'+str+' @extract.list';
  writeln('P: ',p);
  run7Za(p,ListViewA);

end;

end.

