{
  Autor       : Michel Springwald
  
  Erstellt am : Samstag den 28.April.2007
  Upgedatet   : Mittwoch, den 02.Mai.2007
  Histroy     :
}

unit u7zipExtra;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,ComCtrls,Tools,Controls;

type
  TOnFileInfo = procedure(DirCount, FileCount, TotalSize:int64) of Object;

  TOnArchivInfo = procedure(DirCount, FileCount, TotalSize,CompressTotalSize:int64) of Object;

  TDir = class
    dir, {Speichert den Komplenten Pfad einer Datei oder eines Verzeichnisses}
    TempName:String; // ist für den Bearbeitungs Mouds Gedacht
    FileSize:Int64; // Speichert die Datei Größe
  end;

  // Lädt das angeben Verzeichnis in die angeben ListView
  procedure LoadDir(const dirName:String;const ListView:TListView);
  // Fügt alle Einträge von s in die angeben ListView
  // Wobei der LevelDir(Die Aktelle Verzeichnis Ebene)
  // Berücksichtig wird.
  procedure AddLV(const lv:TListView;const s:TStringlist;const levelDir:Integer);
  // Prüft in einer ListView, ob es einen Eintrag schon gibt
  // Wenn nicht wird -1 zurück geben.
  // ist ItemIndex -1 wird von der angeben LV nur die Caption's
  // geprüft, ansonsten werden auch die Subitems berücksichtigt
  function GetLVIndex(const Caption:String; const lv:TListView;ItemIndex:Integer = -1 ):Integer;
  // Sucht in einer Script nach den angeben Wert,z.b.
  // Size
  function GetValue(const Script:TStringList; const s:string; const zeile:Integer):String;
  // Speichert die Dateiliste(Items) von Thread ab
  // Prüft, ob es die agnebe Datei schon gibt
  // Wenn ja wird sie gelöscht.
  // Setzt das Akteulle Verzeichnis auf pFileName
  procedure SaveFileList(const pFileName:String);
  {
    Kopiert alle Markierten Einträge von LV1 nach LV2
    oder Verschiebst sie wenn Moved auf True ist
  }
  procedure CopySelItems(const LV1, LV2:TListView; const Moved:Boolean = False; hablFileName:Boolean = False);
  // Setzt die Größe und Position einer Komponente
  // In die Statusbar.
  procedure AddCompSB(const sb:TStatusBar; const control:TWinControl);

var
  onFileInFo:TOnFileInfo;
  onArchivInfo:TOnArchivInfo;
  // Wird nur für ein Neues Archiv gebraucht
  // Dort wird das Aktuelle Verzeichnis drin gespeichert
  NewDir:String = '';
  // Für das Zürcksetzten der Prossesbar, wenn sie
  // Auf 100 % ist
  t:Integer = 0 ;

  // Wird für Add, Delete gebraucht
  Files:TStringlist;
  // Das Aktuelle geöffnete Archiv
  FileName:String = '';
  // Die Aktuelle Ebene,z.b.: 1 = Home 2 = pluto und soweiter
  dirLevel:Integer = 1;
  TempDir:String = '/home/pluto/7zGuiTemp/';
  SelSize:Integer = 0;
  aDirCount, aFileCount, aTotalSize,aCompressSize:Int64;

implementation

procedure AddCompSB(const sb:TStatusBar; const control:TWinControl);
var
 l,r:Integer;
{
  Setzt die Variablen left und Right auf
  das angeben Panel
}
procedure SetSize(var left, right:Integer);
var
  i,x,m:integer;
begin
  x:=0; m:=0;
  for i:=0 to sb.Panels.Count-1 do begin
    // sobald i den Panel Index erreicht hat
    // werden die left und Right werte gesetzt
    if i = sb.Tag then begin
      left:=x;
      // Wenn der Zähler kleiner als anzahl ist
      // keine Problem mit +1 gibt.
      if i = sb.Panels.Count-1 then m:=0 else m:=+1;
      // Nimmt die Nächste größe.
      right:=x+sb.Panels[i+m].Width;
      break;
    end;
    // zählt solange x + die aktuelle Panel breite
    // zusammen bis i den Akteulln Panel Index erreicht hat
    x:=x+sb.Panels[i].Width;
  end;
end;
begin
  // Hier wird die Control Breite und X Position gesetzt
  SetSize(control.Left,control.Width);
  // Da Top und Height klar sind, müssen sie nicht
  // Ermittelt werden
  Control.Top:=sb.Top; Control.Height:=sb.Height;
end;

procedure LoadDir(const dirName:String;const ListView:TListView);
var
  sr:TSearchRec;
  str:String;
  dir:TDir;
  DirCount, FileCount, TotalSize:Int64;
begin
  DirCount:=0; FileCount:=0; TotalSize:=0;
  
  writeln('u7zipExtra.LoadDir.Dirname:',dirname);
  if FindFirst(dirName + '*' ,faAnyFile and faDirectory,sr) = 0 then begin
    ListView.Items.Clear;
    repeat
      if sr.Name <> '.' then begin
        with ListView.Items.add do begin
          dir:=TDir.Create;
          dir.TempName:='';
          if (sr.Attr and faDirectory) = faDirectory then begin
            if sr.name <> '..' then
            inc(DirCount);
            Caption:='[' + sr.Name + ']';
            dir.dir:=dirName+sr.name + '/';
          end
          else begin
            dir.FileSize:=sr.Size;

            inc(FileCount); inc(TotalSize,dir.FileSize);
            Caption:=sr.Name;
            dir.dir:=dirName+sr.name;
          end;
          Data:=dir;
        end;
      end;
    until FindNext(sr) <> 0
  end;

  if Assigned(onFileInFo) then onFileInFo(DirCount,FileCount,TotalSize);
end;

procedure CopySelItems(const LV1, LV2:TListView; const Moved:Boolean = False; hablFileName:Boolean = False);
var
  i:Integer;
  dir:String;
begin
  for i:=LV1.Items.Count-1 downto 0  do begin
    // Alle Markierten Einträge in die Zweite ListView
    // kopieren bzw. Verschieben.
    if LV1.Items[i].Selected = True then begin
      // Einträge Kopieren
      LV2.Items.add.Assign(LV1.items[i]);

      if hablFileName = True then begin
        dir:=TDir(lv2.Items[lv2.Items.Count-1].Data).dir;
        TDir(lv2.Items[lv2.Items.Count-1].Data).dir:=StringReplace(dir,NewDir,'',[]);
      end;

      // Wenn Verschoben werden soll
      if Moved = True then LV1.Items[i].Delete;
    end;
  end;
end;

procedure SaveFileList(const pFileName:String);
begin
  if FileExists(pFileName) = true then DeleteFile(pFileName);
  Files.SaveToFile(pFileName);
  Writeln('u7ZipExtra.SaveFileList.ExtractFileDir: ',extractFileDir(pFileName));
  SetCurrentDir(extractFileDir(pFileName)+'/'); Files.Clear;
end;

function GetLVIndex(const Caption:String; const lv:TListView;ItemIndex:Integer = -1 ):Integer;
var
  i,z:Integer;
  str:String;
begin
  z:=-1;
  // Damit der Caption nicht städigt umgewandelt werden muss
  // wird es nur einmal getan.
  if ItemIndex = -1 then str:=UpperCase(Caption);

  for i:=0 to lv.Items.Count-1 do begin
    // ist der ItemIndex größer als minus 1
    // Wandeln den wert um
    if ItemIndex > -1 then begin
      // Nur Machen wenn ItemIndex kleiner oder gleich
      // der Anzahl der Spalten entspricht
      if ItemIndex <=lv.items[i].SubItems.Count-1 then begin
        if upperCase(lv.items[i].SubItems[ItemIndex]) = Caption then begin
          z:=i;
          break;
        end;
      end;
    end
    else begin
      if upperCase(lv.items[i].Caption) = str then begin
        z:=i;
        break;
      end;
    end;
    
  end;
  result:=z;
end;

function GetValue(const Script:TStringList;const s:string;const zeile:Integer):String;
var
  i:Integer;
  k:String;
begin
  k:='';
  for i:=Zeile to Script.count-1 do begin
    if Script[i] = '' then
      break
    else begin
      if pos(s,Script[i]) > 0 then begin
        if Pos('=',Script[i]) > 0 then begin
          k:=TrimLeft(GetToken(Script[i],'=',2));
          break;
        end;
      end;
    end;
  end;
  result:=k;
end;

procedure AddLV(const lv:TListView;const s:TStringlist;const levelDir:Integer);
var
  str,str2,tmp:String;
  dir:TDir;
begin
  if (s <> NIL) and (s.count > 0) then begin
    dir:=TDir.Create; dir.TempName:='';
    str2:=TrimLeft(GetToken(s.strings[0],'=',2));
    if pos('D',GetValue(s,'Attributes',3)) = 0 then begin

      if Pos('/',str2) > 0 then begin
        if levelDir <> NumToken(str2,'/') then begin
          str:='['+GetToken(str2,'/',levelDir)+']';
        end
        else str:=GetToken(str2,'/',levelDir)
      end
      else str:=str2;


      if GetLVIndex(str,lv) = -1 then begin

        if str[1] = '[' then
          inc(aDirCount)
        else begin
          inc(aFileCount);
          tmp:=GetValue(s,'Size',0);
          if tmp <> '' then inc(aTotalSize,StrToInt(tmp));
          tmp:=GetValue(s,'Packed Size',0);
          if tmp <> '' then inc(aCompressSize,StrToInt(tmp));

        end;
        with lv.Items.add do begin
          Caption:=str;
          dir.dir:='"'+str2+'"';
          Data:=dir;
        end;
      end;
    end;
  end
  else begin
    if (s = NIL) then begin
      dir:=TDir.Create;
      with lv.Items.add do begin
        Caption:='[..]'; dir.dir:='[..]'; Data:=dir;
      end;
    end;
  end;
end;

Initialization
  Files:=TSTringlist.Create

Finalization
  Files.Free;

end.

