{
  Autor       : Michel Springwald

  Erstellt am : Samstag den 28.April.2007
  Upgedatet   : Donnerstag den 03.Mai.2007
  Histroy     :
}

unit uThread;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,ComCtrls,process,Forms;
  
type
  TSynModusSet = (SPEnabledTrue,SPEnabledFalse,LWAddItems,lwpunkt,prosessbar,DirLoadNew);
  TSynmodus = SPEnabledTrue..DirLoadNew;

  TSynEvt = TThreadMethod;

  TOpenArchiv = class(TThread)
  private
    procedure scd;
  protected
    procedure Execute; override;

  public
    Cancel:Boolean;
    files:TStringlist;
    Para:String;
    lw:TListView;
    items:TStringlist;
    dirlevel:Integer;
    fSynModus:TSynmodus;
    fSyncEvent: TSynEvt;
    status:String;

    Constructor Create(CreateSuspended : boolean);
    destructor Destroy;
  published
    property OnSyncEvent: TSynEvt read fSyncEvent write fSyncEvent;

  end;


implementation


constructor TOpenArchiv.Create(CreateSuspended : boolean);
begin
  items:=TStringlist.Create;
  FreeOnTerminate := True;
  Cancel:=False; Status:='';
  inherited Create(CreateSuspended);
end;

destructor TOpenArchiv.Destroy;
begin

end;

procedure TOpenArchiv.scd;
begin
  if Assigned(OnSyncEvent) then Synchronize(OnSyncEvent);
end;

procedure TOpenArchiv.Execute;
const
  READ_BYTES = 1;//2048;
var
  M: TMemoryStream;
  P: TProcess;
  n: LongInt;
  BytesRead: LongInt;
  str,fz,s:String;
  t:Boolean;
begin
  fSynModus:=SPEnabledTrue;
  Synchronize(@scd);

  fSynModus:=prosessbar;
  if Para[1] = 'l' then begin
    status:='Öffne Archiv'; s:='Öffnen, ';
  end;

  if Para[1] = 'd' then begin
    status:='Einträge aus Archiv löschen'; s:='Löschen, '
  end;

  if Para[1] = 'a' then begin
    status:='Hinzufügen zum Archiv';s:='Hinzufügen, ';
  end;
  
  if Para[1] = 'x' then begin
    status:='Entpacke Archiv'; s:='Entpacke, ';
  end;

  M := TMemoryStream.Create; BytesRead := 0;
  P := TProcess.Create(nil);
  P.CommandLine := '7z '+Para; P.Options := [poUsePipes];
  P.Execute; t:=False;
  str:=''; SetLength(fz,3);

  Synchronize(@lw.BeginUpdate);
  if (dirlevel > 1) then begin
    fSynModus:=lwpunkt; Synchronize(@scd);

  end;

  // Nur Ausführen, wenn eine Liste angefordert wird
  if Para[1] = 'l' then begin
    while (P.Running) and (Cancel = False) do begin
      M.SetSize(BytesRead + READ_BYTES);
      n := P.Output.Read((M.Memory + BytesRead)^, READ_BYTES);m.Read(fz[1],1);
      if fz[1] <> #10 then str:=str+fz[1] else begin
       if Pos('Path',str) > 0 then t:=True;
       if str = '' then begin
          t:=False; fSynModus:=LWAddItems; Synchronize(@scd);
          Synchronize(@items.Clear);
       end;

        if t = True then
          items.add(str);
       str:='';
      end;
      if n > 0 then Inc(BytesRead, n) else Break;
   //   if BytesRead >=9000 then break;
    end;
  end
  else begin
    // Ausführen bei allen anderen Oprationen wie z.b. Hinzufügen
    // oder aber auch bei Löschen, ...
    while (P.Running) and (Cancel = False) do begin
    end;
  end;
  Synchronize(@lw.EndUpdate);

  Writeln('THread.Execute.M.Size: ',m.size);
  Synchronize(@lw.BeginUpdate);
  // Genau wie oben
  if Para[1] = 'l' then begin
    repeat
      if Cancel = True then
        break
      else begin
        M.SetSize(BytesRead + READ_BYTES);
        n := P.Output.Read((M.Memory + BytesRead)^, READ_BYTES); m.Read(fz[1],1);
        if fz[1] <> #10 then str:=str+fz[1] else begin
          if Pos('Path',str) > 0 then t:=True;
          if str = '' then begin
            t:=False;
            fSynModus:=LWAddItems; Synchronize(@scd);
            Synchronize(@items.Clear);
         end;
         if t = True then items.add(str);
          str:='';
       end; if n > 0 then Inc(BytesRead, n) else Break;
     end;
    until (n <= 0) and (Cancel = True);
  end
  else begin
    repeat
      if Cancel = True then  break
    until True;
  end;

  Synchronize(@lw.EndUpdate);
  M.SetSize(BytesRead);
  p.Free;
  m.Free;

  fSynModus:=SPEnabledFalse;
  Synchronize(@scd);
  Writeln('Thread Execute Ende !');

  fSynModus:=prosessbar;

  if Cancel = True then
    status:=s+'Abgebrochen'
  else
    status:=s+'Fertig';

  Synchronize(@scd);

// Wenn entpackt werden soll, soll das Verzeichnis neu geladen
// werden
  if Para[1] = 'x' then begin
    fSynModus:=DirLoadNew; Synchronize(@scd);
  end;

end;

end.

